Go中的 panic / recover 简介与实践记录(go判断字符是否是中文)速看

随心笔谈12个月前发布 admin
92 0



目录简介1.特性2.panic触发流程3.recover使用要点4.使用场景一、实践1.跨线程失效2.不起作用的recover3.嵌套使用panic4.注意事项小结

go语言追求简洁,所以go语言中没有try…catch语句。因为go语言的作者认为将异常和控制语句混在一起,很容易让这个程序变得混乱,异常也很容易被滥用。 所以在go语言中,为了防止异常被滥用。我们常常使用函数的返回值来返回错误,而不是用异常来代替错误。如果在一些场景下确实需要处理异常,就可以使用panic和recover。panic用来抛出异常,recover用来恢复异常。

panic是Go语言中,用于终止程序的一种函数,往往用在下面两种情况:1)程序出现了很大的故障,例如不能在提供服务了。2)程序在运行阶段碰到了内存异常的操作,例如空指针的取值,改写只读内存等。对于panic来说,1)场景往往是主动调用;2)场景则是被动调用,panic一旦产生之后,会将堆栈里面的数据dump出来,这样就方便了开发人员来定位问题。recover是用来截获panic异常信息的,截获了之后,可以控制程序跳过panic的地方继续执行。

需要注意:

panic 能够改变程序的控制流,调用 panic 后会立刻停止执行当前函数的剩余代码,并在当前 Goroutine 中递归执行调用方的 defer;recover 可以中止 panic 造成的程序崩溃。它是一个只能在 defer 中发挥作用的函数,在其他作用域中调用不会发挥作用;

panic 只会触发当前goroutine的deferrevoce 只有在defer中调用才能生效panic 允许在defer中嵌套多磁调用

1.如果函数F中书写并触发了panic语句,会终止其后要执行的代码。在panic所在函数F内如果存在要执行的defer函数列表,则按照defer书写顺序的逆序执行;2.如果函数G调用函数F,则函数F panic后返回调用者函数G。函数G中,调用函数F语句之后的语句都不会执行。假如函数G中也有要执行的defer函数列表,则按照defer书写顺序的逆序子还行;退出整个goroutine,并报告错误。

recover的作用是捕获panic,从而恢复正常代码执行;recover必须配合defer使用;recover没有传入参数,但是有返回值,返回值就是panic传递的值

一般情况下有两种情况用到:

程序遇到无法执行下去的错误时,抛出错误,主动结束运行。在调试程序时,通过 panic 来打印堆栈,方便定位错误。

package main
import (
“fmt”
“time”
)
func main() {
// 主线程中的defer函数并不会执行,因为子协程 panic后,主线程中的defer并不会执行
defer println(“in main”)
go func() {
defer println(“in goroutine”)
fmt.Println(“子协程running”)
panic(“子协程崩溃”)
}()
time.Sleep(1 * time.Second)
}
# 输出
$ go run main.go
子协程running
in goroutine
panic: 子协程崩溃
goroutine 6 [running]:
main.main.func1()

当运行这段代码时会发现 main 函数中的 defer 语句并没有执行,执行的只有当前 Goroutine 中的 defer。

初学 Go 语言工程师可能会写出下面的代码,在主程序中调用 recover 试图中止程序的崩溃,但是从运行的结果中也能看出,下面的程序没有正常退出。

package main
import “fmt”
func main() {
defer fmt.Println(“in main”)
if err :=recover(); err !=nil {
fmt.Println(err)
}
panic(“unknown err”)
}
# 输出
$ go run main.go
in main
panic: unknown err
goroutine 1 [running]:
main.main()
D:/gopath/src/Go_base/lesson/panic/demo5.go:11 +0x125

仔细分析一下这个过程就能理解这种现象背后的原因,recover 只有在发生 panic 之后调用才会生效。然而在上面的控制流中,recover 是在 panic 之前调用的,并不满足生效的条件,所以我们需要在 defer 中使用 recover 关键字。

正确的写法应该是这样:

package main
import “fmt”
func main() {
defer fmt.Println(“in main”)
defer func() {
if err :=recover(); err !=nil {
fmt.Println(“occur error”)
fmt.Println(err)
}
}()
panic(“unknown err”)
}

panic 是可以多次嵌套调用的。,如下所示的代码就展示了如何在 defer 函数中多次调用 panic:

package main
import “fmt”
func main() {
defer fmt.Println(“in main”)
defer func() {
defer func() {
panic(“panic again and again”)
}()
panic(“panic again”)
}()
panic(“panic once”)
}
# 输出
$ go run main.go
in main
panic: panic once
panic: panic again
panic: panic again and again
goroutine 1 [running]:
main.main.func1.1()

从上述程序输出的结果,我们可以确定程序多次调用 panic 也不会影响 defer 函数的正常执行,所以使用 defer 进行收尾工作一般来说都是安全的。

1.recover 语法

//以下捕获失败
defer recover()
defer fmt.Prinntln(recover)
defer func(){
func(){
recover() //无效,嵌套两层
}()
}()
//以下捕获有效
defer func(){
recover()
}()
func except(){
recover()
}
func test(){
defer except()
panic(“runtime error”)
}

2.多个panic只会捕捉最后一个

package main
import “fmt”
func main(){
defer func(){
if err :=recover() ; err !=nil {
fmt.Println(err)
}
}()
defer func(){
panic(“three”)
}()
defer func(){
panic(“two”)
}()
panic(“one”)
}

到此这篇关于Go中的 panic / recover 简介与实践的文章就介绍到这了,更多相关go panic / recover 内容请搜索脚本之家以前的文章或继续浏览下面的相关文章希望大家以后多多支持脚本之家!

您可能感兴趣的文章:一文带你掌握Golang中panic与recover的使用方法Go语言异常处理(Panic和recovering)用法详解Golang中panic与recover的区别Golang异常处理之defer,panic,recover的使用详解Go基础教程系列之defer、panic和recover详解go语言异常panic和恢复recover用法实例GO语言异常处理机制panic和recover分析

© 版权声明

相关文章